/*-
 * ~~~~~~licensing~~~~~~
 * atlasmap-entaxy-libs
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package io.atlasmap.entaxy;

import java.util.List;

import org.osgi.framework.BundleContext;
import org.osgi.framework.FrameworkUtil;
import org.osgi.framework.ServiceReference;

import ru.entaxy.platform.modules.datamapper.DataMapper;
import ru.entaxy.platform.modules.datamapper.DataMapperService;

public class DataMapperLookup implements ValuesLookup {

    public List<String> getValues() {
        List<String> result = null;
        BundleContext bundleContext = FrameworkUtil.getBundle(DataMapper.class).getBundleContext();
        if (bundleContext == null)
            return null;
        ServiceReference<DataMapperService> ref =
                bundleContext.getServiceReference(DataMapperService.class);
        if (ref == null)
            return null;
        DataMapperService dataMapperService = bundleContext.getService(ref);
        if (dataMapperService != null)
            result = dataMapperService.getMapSignaturesSorted();
        try {
            bundleContext.ungetService(ref);
        } catch (Exception ignore) {
            // noop
        }
        return result;
    }

}
